#!/bin/sh
#
# portSlkDb2PacDb.sh
#
# by Gernot WALZL   2009-07-07
#

SLK_PKG_DB="/var/log/packages/"
PAC_PKG_DB="/var/lib/pacman/local/"

BLUE="\033[1;34m"
NC="\033[0m"


function list_slk_pkg_files {
    SLK_PKG="$1"
    ENABLE_OUT=0
    while read line; do
        if [ "$ENABLE_OUT" -eq 1 ]; then
            if [ "$line" == "./" ]; then
                continue
            fi
            if [ "${line:0:8}" == "install/" ]; then
                continue
            fi
            echo $line
            continue
        fi
        if [ "$line" == "FILE LIST:" ]; then
            ENABLE_OUT=1
        fi
    done < "${SLK_PKG_DB}${SLK_PKG}"
}


function port_pkg {
    SLK_PKG="$1"

    BUILD=${SLK_PKG##*-}
    REST=${SLK_PKG%-*}
    ARCH=${REST##*-}
    REST=${REST%-*}
    VERSION=${REST##*-}
    NAME=${REST%-*}

    PAC_PKG="${NAME}-${VERSION}-${BUILD}"

    echo -e "${SLK_PKG} ${BLUE}->${NC} ${PAC_PKG}"

    DIR="${PAC_PKG_DB}${PAC_PKG}"
    mkdir -p "$DIR" || return 1
    cd "$DIR"

    echo "%DEPENDS%" > depends || return 1
    echo "" >> depends
    if [ "$NAME" == "bash" ] || \
       [ "$NAME" == "zsh" ] || \
       [ "$NAME" == "ash" ]; then
        echo "%PROVIDES%" >> depends
        echo "sh" >> depends
        echo "" >> depends
    fi

    echo "%NAME%" > desc || return 1
    echo "$NAME" >> desc
    echo "" >> desc
    echo "%VERSION%" >> desc
    echo "${VERSION}-${BUILD}" >> desc
    echo "" >> desc
    if [ "$NAME" != "pacman" ] && \
       [ "$NAME" != "libdownload" ]; then
        echo "%GROUPS%" >> desc
        echo "slackware" >> desc
        echo "" >> desc
    fi
    echo "%ARCH%" >> desc
    echo "$ARCH" >> desc
    echo "" >> desc

    echo "%FILES%" > files || return 1
    list_slk_pkg_files "$SLK_PKG" >> files
    echo "" >> files

    echo "$PAC_PKG" >> "${PAC_PKG_DB}imported"
}


function port_all {
    echo -e "${BLUE}Porting Slackware Database to Pacman Database${NC}"
    echo -e "${BLUE}SlkPkgDb: ${SLK_PKG_DB}${NC}"
    echo -e "${BLUE}PacPkgDb: ${PAC_PKG_DB}${NC}"
    CWD=$(pwd)
    for file in $(ls ${SLK_PKG_DB}); do
        port_pkg "$file"
    done
    cd $CWD
}


function remove_old {
    if [ -f "${PAC_PKG_DB}imported" ]; then
        echo -e "${BLUE}Removing previously imported packages${NC}"
        while read line; do
            echo "$line"
            rm -r "${PAC_PKG_DB}${line}"
        done < "${PAC_PKG_DB}imported"
    fi
    rm -f "${PAC_PKG_DB}imported"
}


remove_old
port_all

